import { Context, NextIOHandler } from '@hprose/rpc-core';
export interface WeightedURIList {
    [uri: string]: number;
}
export declare abstract class WeightedLoadBalance {
    protected readonly uris: string[];
    protected readonly weights: number[];
    constructor(uriList: WeightedURIList);
    abstract handler(request: Uint8Array, context: Context, next: NextIOHandler): Promise<Uint8Array>;
}
export declare class RandomLoadBalance {
    handler(request: Uint8Array, context: Context, next: NextIOHandler): Promise<Uint8Array>;
}
export declare class WeightedRandomLoadBalance extends WeightedLoadBalance {
    private readonly effectiveWeights;
    constructor(uriList: WeightedURIList);
    handler: (request: Uint8Array, context: Context, next: NextIOHandler) => Promise<Uint8Array>;
}
export declare class RoundRobinLoadBalance {
    private index;
    handler: (request: Uint8Array, context: Context, next: NextIOHandler) => Promise<Uint8Array>;
}
export declare class WeightedRoundRobinLoadBalance extends WeightedLoadBalance {
    private readonly maxWeight;
    private readonly gcdWeight;
    private index;
    private currentWeight;
    constructor(uriList: WeightedURIList);
    handler: (request: Uint8Array, context: Context, next: NextIOHandler) => Promise<Uint8Array>;
}
export declare class NginxRoundRobinLoadBalance extends WeightedLoadBalance {
    private readonly effectiveWeights;
    private readonly currentWeights;
    constructor(uriList: WeightedURIList);
    handler: (request: Uint8Array, context: Context, next: NextIOHandler) => Promise<Uint8Array>;
}
export declare class LeastActiveLoadBalance {
    private readonly actives;
    handler: (request: Uint8Array, context: Context, next: NextIOHandler) => Promise<Uint8Array>;
}
export declare class WeightedLeastActiveLoadBalance extends WeightedLoadBalance {
    private readonly effectiveWeights;
    private readonly actives;
    constructor(uriList: WeightedURIList);
    handler: (request: Uint8Array, context: Context, next: NextIOHandler) => Promise<Uint8Array>;
}
//# sourceMappingURL=index.d.ts.map